module Hansi
  PALETTES = {}
  private_constant :PALETTES

  reset_css = {
    color:            :inherit,
    font_weight:      :normal,
    font_syle:        :normal,
    text_decoration:  :none,
    visibility:       :visible
  }

  PALETTES['special'] = {
    reset:            Hansi::Special.new(0, reset_css),
    bold:             Hansi::Special.new(1, font_weight: :bold),
    faint:            Hansi::Special.new(2, font_weight: :lighter),
    italic:           Hansi::Special.new(3, font_style: :italic),
    underline:        Hansi::Special.new(4, text_decoration: :underline),
    blink:            Hansi::Special.new(5, text_decoration: :blink),
    rapid_blink:      Hansi::Special.new(6, text_decoration: :blink),
    inverse:          Hansi::Special.new(7),
    reverse:          Hansi::Special.new(7),
    conceal:          Hansi::Special.new(8, visibility: :hidden),
    crossed_out:      Hansi::Special.new(9, text_decoration: :line_through),
    default:          Hansi::Special.new(10),
    fraktur:          Hansi::Special.new(20),
    framed:           Hansi::Special.new(51),
    encircled:        Hansi::Special.new(52),
    overline:         Hansi::Special.new(54, text_decoration: :overline),
  }

  PALETTES['ansi'] = {
    "\e[30m" => Hansi[   0,   0,   0 ],
    "\e[31m" => Hansi[ 194,  54,  33 ],
    "\e[32m" => Hansi[  37, 188,  36 ],
    "\e[33m" => Hansi[ 173, 173,  39 ],
    "\e[34m" => Hansi[  73,  46, 225 ],
    "\e[35m" => Hansi[ 211,  56, 211 ],
    "\e[36m" => Hansi[  51, 187, 200 ],
    "\e[37m" => Hansi[ 203, 204, 205 ]
  }

  PALETTES['xterm'] = {
    "\e[90m" => Hansi[ 129, 131, 131 ],
    "\e[91m" => Hansi[ 252,  57,  31 ],
    "\e[92m" => Hansi[  49, 231,  34 ],
    "\e[93m" => Hansi[ 234, 236,  35 ],
    "\e[94m" => Hansi[  88,  51, 255 ],
    "\e[95m" => Hansi[ 249,  53, 248 ],
    "\e[96m" => Hansi[  20, 240, 240 ],
    "\e[97m" => Hansi[ 233, 235, 235 ]
  }.merge(PALETTES['ansi'])

  PALETTES['xterm-88color'] = {
    "\e[38;5;0m"  => Hansi[   0,   0,   0 ],
    "\e[38;5;1m"  => Hansi[ 205,   0,   0 ],
    "\e[38;5;2m"  => Hansi[   0, 205,   0 ],
    "\e[38;5;3m"  => Hansi[ 205, 205,   0 ],
    "\e[38;5;4m"  => Hansi[  30, 144, 255 ],
    "\e[38;5;5m"  => Hansi[ 205,   0, 205 ],
    "\e[38;5;6m"  => Hansi[   0, 205, 205 ],
    "\e[38;5;7m"  => Hansi[ 229, 229, 229 ],
    "\e[38;5;8m"  => Hansi[ 127, 127, 127 ],
    "\e[38;5;9m"  => Hansi[ 255,   0,   0 ],
    "\e[38;5;10m" => Hansi[   0, 255,   0 ],
    "\e[38;5;11m" => Hansi[ 255, 255,   0 ],
    "\e[38;5;12m" => Hansi[  99, 184, 255 ],
    "\e[38;5;13m" => Hansi[ 255,   0, 255 ],
    "\e[38;5;14m" => Hansi[   0, 255, 255 ],
    "\e[38;5;15m" => Hansi[ 255, 255, 255 ],
    "\e[38;5;16m" => Hansi[   0,   0,   0 ],
    "\e[38;5;17m" => Hansi[   0,   0, 139 ],
    "\e[38;5;18m" => Hansi[   0,   0, 205 ],
    "\e[38;5;19m" => Hansi[   0,   0, 255 ],
    "\e[38;5;20m" => Hansi[   0, 139,   0 ],
    "\e[38;5;21m" => Hansi[   0, 139, 139 ],
    "\e[38;5;22m" => Hansi[   0, 139, 205 ],
    "\e[38;5;23m" => Hansi[   0, 139, 255 ],
    "\e[38;5;24m" => Hansi[   0, 205,   0 ],
    "\e[38;5;25m" => Hansi[   0, 205, 139 ],
    "\e[38;5;26m" => Hansi[   0, 205, 205 ],
    "\e[38;5;27m" => Hansi[   0, 205, 255 ],
    "\e[38;5;28m" => Hansi[   0, 255,   0 ],
    "\e[38;5;29m" => Hansi[   0, 255, 139 ],
    "\e[38;5;30m" => Hansi[   0, 255, 205 ],
    "\e[38;5;31m" => Hansi[   0, 255, 255 ],
    "\e[38;5;32m" => Hansi[ 139,   0,   0 ],
    "\e[38;5;33m" => Hansi[ 139,   0, 139 ],
    "\e[38;5;34m" => Hansi[ 139,   0, 205 ],
    "\e[38;5;35m" => Hansi[ 139,   0, 255 ],
    "\e[38;5;36m" => Hansi[ 139, 139,   0 ],
    "\e[38;5;37m" => Hansi[ 139, 139, 139 ],
    "\e[38;5;38m" => Hansi[ 139, 139, 205 ],
    "\e[38;5;39m" => Hansi[ 139, 139, 255 ],
    "\e[38;5;40m" => Hansi[ 139, 205,   0 ],
    "\e[38;5;41m" => Hansi[ 139, 205, 139 ],
    "\e[38;5;42m" => Hansi[ 139, 205, 205 ],
    "\e[38;5;43m" => Hansi[ 139, 205, 255 ],
    "\e[38;5;44m" => Hansi[ 139, 255,   0 ],
    "\e[38;5;45m" => Hansi[ 139, 255, 139 ],
    "\e[38;5;46m" => Hansi[ 139, 255, 205 ],
    "\e[38;5;47m" => Hansi[ 139, 255, 255 ],
    "\e[38;5;48m" => Hansi[ 205,   0,   0 ],
    "\e[38;5;49m" => Hansi[ 205,   0, 139 ],
    "\e[38;5;50m" => Hansi[ 205,   0, 205 ],
    "\e[38;5;51m" => Hansi[ 205,   0, 255 ],
    "\e[38;5;52m" => Hansi[ 205, 139,   0 ],
    "\e[38;5;53m" => Hansi[ 205, 139, 139 ],
    "\e[38;5;54m" => Hansi[ 205, 139, 205 ],
    "\e[38;5;55m" => Hansi[ 205, 139, 255 ],
    "\e[38;5;56m" => Hansi[ 205, 205,   0 ],
    "\e[38;5;57m" => Hansi[ 205, 205, 139 ],
    "\e[38;5;58m" => Hansi[ 205, 205, 205 ],
    "\e[38;5;59m" => Hansi[ 205, 205, 255 ],
    "\e[38;5;60m" => Hansi[ 205, 255,   0 ],
    "\e[38;5;61m" => Hansi[ 205, 255, 139 ],
    "\e[38;5;62m" => Hansi[ 205, 255, 205 ],
    "\e[38;5;63m" => Hansi[ 205, 255, 255 ],
    "\e[38;5;64m" => Hansi[ 255,   0,   0 ],
    "\e[38;5;65m" => Hansi[ 255,   0, 139 ],
    "\e[38;5;66m" => Hansi[ 255,   0, 205 ],
    "\e[38;5;67m" => Hansi[ 255,   0, 255 ],
    "\e[38;5;68m" => Hansi[ 255, 139,   0 ],
    "\e[38;5;69m" => Hansi[ 255, 139, 139 ],
    "\e[38;5;70m" => Hansi[ 255, 139, 205 ],
    "\e[38;5;71m" => Hansi[ 255, 139, 255 ],
    "\e[38;5;72m" => Hansi[ 255, 205,   0 ],
    "\e[38;5;73m" => Hansi[ 255, 205, 139 ],
    "\e[38;5;74m" => Hansi[ 255, 205, 205 ],
    "\e[38;5;75m" => Hansi[ 255, 205, 255 ],
    "\e[38;5;76m" => Hansi[ 255, 255,   0 ],
    "\e[38;5;77m" => Hansi[ 255, 255, 139 ],
    "\e[38;5;78m" => Hansi[ 255, 255, 205 ],
    "\e[38;5;79m" => Hansi[ 255, 255, 255 ],
    "\e[38;5;80m" => Hansi[  46,  46,  46 ],
    "\e[38;5;81m" => Hansi[  92,  92,  92 ],
    "\e[38;5;82m" => Hansi[ 113, 113, 113 ],
    "\e[38;5;83m" => Hansi[ 139, 139, 139 ],
    "\e[38;5;84m" => Hansi[ 162, 162, 162 ],
    "\e[38;5;85m" => Hansi[ 185, 185, 185 ],
    "\e[38;5;86m" => Hansi[ 208, 208, 208 ],
    "\e[38;5;87m" => Hansi[ 231, 231, 231 ]
  }

  PALETTES['xterm-256color'] = {
    "\e[38;5;0m"   => Hansi["000000"],
    "\e[38;5;1m"   => Hansi["800000"],
    "\e[38;5;2m"   => Hansi["008000"],
    "\e[38;5;3m"   => Hansi["808000"],
    "\e[38;5;4m"   => Hansi["000080"],
    "\e[38;5;5m"   => Hansi["800080"],
    "\e[38;5;6m"   => Hansi["008080"],
    "\e[38;5;7m"   => Hansi["c0c0c0"],
    "\e[38;5;8m"   => Hansi["808080"],
    "\e[38;5;9m"   => Hansi["ff0000"],
    "\e[38;5;10m"  => Hansi["00ff00"],
    "\e[38;5;11m"  => Hansi["ffff00"],
    "\e[38;5;12m"  => Hansi["0000ff"],
    "\e[38;5;13m"  => Hansi["ff00ff"],
    "\e[38;5;14m"  => Hansi["00ffff"],
    "\e[38;5;15m"  => Hansi["ffffff"],
    "\e[38;5;16m"  => Hansi["000000"],
    "\e[38;5;17m"  => Hansi["00005f"],
    "\e[38;5;18m"  => Hansi["000087"],
    "\e[38;5;19m"  => Hansi["0000af"],
    "\e[38;5;20m"  => Hansi["0000d7"],
    "\e[38;5;21m"  => Hansi["0000ff"],
    "\e[38;5;22m"  => Hansi["005f00"],
    "\e[38;5;23m"  => Hansi["005f5f"],
    "\e[38;5;24m"  => Hansi["005f87"],
    "\e[38;5;25m"  => Hansi["005faf"],
    "\e[38;5;26m"  => Hansi["005fd7"],
    "\e[38;5;27m"  => Hansi["005fff"],
    "\e[38;5;28m"  => Hansi["008700"],
    "\e[38;5;29m"  => Hansi["00875f"],
    "\e[38;5;30m"  => Hansi["008787"],
    "\e[38;5;31m"  => Hansi["0087af"],
    "\e[38;5;32m"  => Hansi["0087d7"],
    "\e[38;5;33m"  => Hansi["0087ff"],
    "\e[38;5;34m"  => Hansi["00af00"],
    "\e[38;5;35m"  => Hansi["00af5f"],
    "\e[38;5;36m"  => Hansi["00af87"],
    "\e[38;5;37m"  => Hansi["00afaf"],
    "\e[38;5;38m"  => Hansi["00afd7"],
    "\e[38;5;39m"  => Hansi["00afff"],
    "\e[38;5;40m"  => Hansi["00d700"],
    "\e[38;5;41m"  => Hansi["00d75f"],
    "\e[38;5;42m"  => Hansi["00d787"],
    "\e[38;5;43m"  => Hansi["00d7af"],
    "\e[38;5;44m"  => Hansi["00d7d7"],
    "\e[38;5;45m"  => Hansi["00d7ff"],
    "\e[38;5;46m"  => Hansi["00ff00"],
    "\e[38;5;47m"  => Hansi["00ff5f"],
    "\e[38;5;48m"  => Hansi["00ff87"],
    "\e[38;5;49m"  => Hansi["00ffaf"],
    "\e[38;5;50m"  => Hansi["00ffd7"],
    "\e[38;5;51m"  => Hansi["00ffff"],
    "\e[38;5;52m"  => Hansi["5f0000"],
    "\e[38;5;53m"  => Hansi["5f005f"],
    "\e[38;5;54m"  => Hansi["5f0087"],
    "\e[38;5;55m"  => Hansi["5f00af"],
    "\e[38;5;56m"  => Hansi["5f00d7"],
    "\e[38;5;57m"  => Hansi["5f00ff"],
    "\e[38;5;58m"  => Hansi["5f5f00"],
    "\e[38;5;59m"  => Hansi["5f5f5f"],
    "\e[38;5;60m"  => Hansi["5f5f87"],
    "\e[38;5;61m"  => Hansi["5f5faf"],
    "\e[38;5;62m"  => Hansi["5f5fd7"],
    "\e[38;5;63m"  => Hansi["5f5fff"],
    "\e[38;5;64m"  => Hansi["5f8700"],
    "\e[38;5;65m"  => Hansi["5f875f"],
    "\e[38;5;66m"  => Hansi["5f8787"],
    "\e[38;5;67m"  => Hansi["5f87af"],
    "\e[38;5;68m"  => Hansi["5f87d7"],
    "\e[38;5;69m"  => Hansi["5f87ff"],
    "\e[38;5;70m"  => Hansi["5faf00"],
    "\e[38;5;71m"  => Hansi["5faf5f"],
    "\e[38;5;72m"  => Hansi["5faf87"],
    "\e[38;5;73m"  => Hansi["5fafaf"],
    "\e[38;5;74m"  => Hansi["5fafd7"],
    "\e[38;5;75m"  => Hansi["5fafff"],
    "\e[38;5;76m"  => Hansi["5fd700"],
    "\e[38;5;77m"  => Hansi["5fd75f"],
    "\e[38;5;78m"  => Hansi["5fd787"],
    "\e[38;5;79m"  => Hansi["5fd7af"],
    "\e[38;5;80m"  => Hansi["5fd7d7"],
    "\e[38;5;81m"  => Hansi["5fd7ff"],
    "\e[38;5;82m"  => Hansi["5fff00"],
    "\e[38;5;83m"  => Hansi["5fff5f"],
    "\e[38;5;84m"  => Hansi["5fff87"],
    "\e[38;5;85m"  => Hansi["5fffaf"],
    "\e[38;5;86m"  => Hansi["5fffd7"],
    "\e[38;5;87m"  => Hansi["5fffff"],
    "\e[38;5;88m"  => Hansi["870000"],
    "\e[38;5;89m"  => Hansi["87005f"],
    "\e[38;5;90m"  => Hansi["870087"],
    "\e[38;5;91m"  => Hansi["8700af"],
    "\e[38;5;92m"  => Hansi["8700d7"],
    "\e[38;5;93m"  => Hansi["8700ff"],
    "\e[38;5;94m"  => Hansi["875f00"],
    "\e[38;5;95m"  => Hansi["875f5f"],
    "\e[38;5;96m"  => Hansi["875f87"],
    "\e[38;5;97m"  => Hansi["875faf"],
    "\e[38;5;98m"  => Hansi["875fd7"],
    "\e[38;5;99m"  => Hansi["875fff"],
    "\e[38;5;100m" => Hansi["878700"],
    "\e[38;5;101m" => Hansi["87875f"],
    "\e[38;5;102m" => Hansi["878787"],
    "\e[38;5;103m" => Hansi["8787af"],
    "\e[38;5;104m" => Hansi["8787d7"],
    "\e[38;5;105m" => Hansi["8787ff"],
    "\e[38;5;106m" => Hansi["87af00"],
    "\e[38;5;107m" => Hansi["87af5f"],
    "\e[38;5;108m" => Hansi["87af87"],
    "\e[38;5;109m" => Hansi["87afaf"],
    "\e[38;5;110m" => Hansi["87afd7"],
    "\e[38;5;111m" => Hansi["87afff"],
    "\e[38;5;112m" => Hansi["87d700"],
    "\e[38;5;113m" => Hansi["87d75f"],
    "\e[38;5;114m" => Hansi["87d787"],
    "\e[38;5;115m" => Hansi["87d7af"],
    "\e[38;5;116m" => Hansi["87d7d7"],
    "\e[38;5;117m" => Hansi["87d7ff"],
    "\e[38;5;118m" => Hansi["87ff00"],
    "\e[38;5;119m" => Hansi["87ff5f"],
    "\e[38;5;120m" => Hansi["87ff87"],
    "\e[38;5;121m" => Hansi["87ffaf"],
    "\e[38;5;122m" => Hansi["87ffd7"],
    "\e[38;5;123m" => Hansi["87ffff"],
    "\e[38;5;124m" => Hansi["af0000"],
    "\e[38;5;125m" => Hansi["af005f"],
    "\e[38;5;126m" => Hansi["af0087"],
    "\e[38;5;127m" => Hansi["af00af"],
    "\e[38;5;128m" => Hansi["af00d7"],
    "\e[38;5;129m" => Hansi["af00ff"],
    "\e[38;5;130m" => Hansi["af5f00"],
    "\e[38;5;131m" => Hansi["af5f5f"],
    "\e[38;5;132m" => Hansi["af5f87"],
    "\e[38;5;133m" => Hansi["af5faf"],
    "\e[38;5;134m" => Hansi["af5fd7"],
    "\e[38;5;135m" => Hansi["af5fff"],
    "\e[38;5;136m" => Hansi["af8700"],
    "\e[38;5;137m" => Hansi["af875f"],
    "\e[38;5;138m" => Hansi["af8787"],
    "\e[38;5;139m" => Hansi["af87af"],
    "\e[38;5;140m" => Hansi["af87d7"],
    "\e[38;5;141m" => Hansi["af87ff"],
    "\e[38;5;142m" => Hansi["afaf00"],
    "\e[38;5;143m" => Hansi["afaf5f"],
    "\e[38;5;144m" => Hansi["afaf87"],
    "\e[38;5;145m" => Hansi["afafaf"],
    "\e[38;5;146m" => Hansi["afafd7"],
    "\e[38;5;147m" => Hansi["afafff"],
    "\e[38;5;148m" => Hansi["afd700"],
    "\e[38;5;149m" => Hansi["afd75f"],
    "\e[38;5;150m" => Hansi["afd787"],
    "\e[38;5;151m" => Hansi["afd7af"],
    "\e[38;5;152m" => Hansi["afd7d7"],
    "\e[38;5;153m" => Hansi["afd7ff"],
    "\e[38;5;154m" => Hansi["afff00"],
    "\e[38;5;155m" => Hansi["afff5f"],
    "\e[38;5;156m" => Hansi["afff87"],
    "\e[38;5;157m" => Hansi["afffaf"],
    "\e[38;5;158m" => Hansi["afffd7"],
    "\e[38;5;159m" => Hansi["afffff"],
    "\e[38;5;160m" => Hansi["d70000"],
    "\e[38;5;161m" => Hansi["d7005f"],
    "\e[38;5;162m" => Hansi["d70087"],
    "\e[38;5;163m" => Hansi["d700af"],
    "\e[38;5;164m" => Hansi["d700d7"],
    "\e[38;5;165m" => Hansi["d700ff"],
    "\e[38;5;166m" => Hansi["d75f00"],
    "\e[38;5;167m" => Hansi["d75f5f"],
    "\e[38;5;168m" => Hansi["d75f87"],
    "\e[38;5;169m" => Hansi["d75faf"],
    "\e[38;5;170m" => Hansi["d75fd7"],
    "\e[38;5;171m" => Hansi["d75fff"],
    "\e[38;5;172m" => Hansi["d78700"],
    "\e[38;5;173m" => Hansi["d7875f"],
    "\e[38;5;174m" => Hansi["d78787"],
    "\e[38;5;175m" => Hansi["d787af"],
    "\e[38;5;176m" => Hansi["d787d7"],
    "\e[38;5;177m" => Hansi["d787ff"],
    "\e[38;5;178m" => Hansi["dfaf00"],
    "\e[38;5;179m" => Hansi["dfaf5f"],
    "\e[38;5;180m" => Hansi["dfaf87"],
    "\e[38;5;181m" => Hansi["dfafaf"],
    "\e[38;5;182m" => Hansi["dfafdf"],
    "\e[38;5;183m" => Hansi["dfafff"],
    "\e[38;5;184m" => Hansi["dfdf00"],
    "\e[38;5;185m" => Hansi["dfdf5f"],
    "\e[38;5;186m" => Hansi["dfdf87"],
    "\e[38;5;187m" => Hansi["dfdfaf"],
    "\e[38;5;188m" => Hansi["dfdfdf"],
    "\e[38;5;189m" => Hansi["dfdfff"],
    "\e[38;5;190m" => Hansi["dfff00"],
    "\e[38;5;191m" => Hansi["dfff5f"],
    "\e[38;5;192m" => Hansi["dfff87"],
    "\e[38;5;193m" => Hansi["dfffaf"],
    "\e[38;5;194m" => Hansi["dfffdf"],
    "\e[38;5;195m" => Hansi["dfffff"],
    "\e[38;5;196m" => Hansi["ff0000"],
    "\e[38;5;197m" => Hansi["ff005f"],
    "\e[38;5;198m" => Hansi["ff0087"],
    "\e[38;5;199m" => Hansi["ff00af"],
    "\e[38;5;200m" => Hansi["ff00df"],
    "\e[38;5;201m" => Hansi["ff00ff"],
    "\e[38;5;202m" => Hansi["ff5f00"],
    "\e[38;5;203m" => Hansi["ff5f5f"],
    "\e[38;5;204m" => Hansi["ff5f87"],
    "\e[38;5;205m" => Hansi["ff5faf"],
    "\e[38;5;206m" => Hansi["ff5fdf"],
    "\e[38;5;207m" => Hansi["ff5fff"],
    "\e[38;5;208m" => Hansi["ff8700"],
    "\e[38;5;209m" => Hansi["ff875f"],
    "\e[38;5;210m" => Hansi["ff8787"],
    "\e[38;5;211m" => Hansi["ff87af"],
    "\e[38;5;212m" => Hansi["ff87df"],
    "\e[38;5;213m" => Hansi["ff87ff"],
    "\e[38;5;214m" => Hansi["ffaf00"],
    "\e[38;5;215m" => Hansi["ffaf5f"],
    "\e[38;5;216m" => Hansi["ffaf87"],
    "\e[38;5;217m" => Hansi["ffafaf"],
    "\e[38;5;218m" => Hansi["ffafdf"],
    "\e[38;5;219m" => Hansi["ffafff"],
    "\e[38;5;220m" => Hansi["ffdf00"],
    "\e[38;5;221m" => Hansi["ffdf5f"],
    "\e[38;5;222m" => Hansi["ffdf87"],
    "\e[38;5;223m" => Hansi["ffdfaf"],
    "\e[38;5;224m" => Hansi["ffdfdf"],
    "\e[38;5;225m" => Hansi["ffdfff"],
    "\e[38;5;226m" => Hansi["ffff00"],
    "\e[38;5;227m" => Hansi["ffff5f"],
    "\e[38;5;228m" => Hansi["ffff87"],
    "\e[38;5;229m" => Hansi["ffffaf"],
    "\e[38;5;230m" => Hansi["ffffdf"],
    "\e[38;5;231m" => Hansi["ffffff"],
    "\e[38;5;232m" => Hansi["080808"],
    "\e[38;5;233m" => Hansi["121212"],
    "\e[38;5;234m" => Hansi["1c1c1c"],
    "\e[38;5;235m" => Hansi["262626"],
    "\e[38;5;236m" => Hansi["303030"],
    "\e[38;5;237m" => Hansi["3a3a3a"],
    "\e[38;5;238m" => Hansi["444444"],
    "\e[38;5;239m" => Hansi["4e4e4e"],
    "\e[38;5;240m" => Hansi["585858"],
    "\e[38;5;241m" => Hansi["626262"],
    "\e[38;5;242m" => Hansi["6c6c6c"],
    "\e[38;5;243m" => Hansi["767676"],
    "\e[38;5;244m" => Hansi["808080"],
    "\e[38;5;245m" => Hansi["8a8a8a"],
    "\e[38;5;246m" => Hansi["949494"],
    "\e[38;5;247m" => Hansi["9e9e9e"],
    "\e[38;5;248m" => Hansi["a8a8a8"],
    "\e[38;5;249m" => Hansi["b2b2b2"],
    "\e[38;5;250m" => Hansi["bcbcbc"],
    "\e[38;5;251m" => Hansi["c6c6c6"],
    "\e[38;5;252m" => Hansi["d0d0d0"],
    "\e[38;5;253m" => Hansi["dadada"],
    "\e[38;5;254m" => Hansi["e4e4e4"],
    "\e[38;5;255m" => Hansi["eeeeee"]
  }

  PALETTES['web'] = {
    aliceblue:            Hansi["f0f8ff"],
    aluminum:             Hansi["999999"],
    antiquewhite:         Hansi["faebd7"],
    aqua:                 Hansi["00ffff"],
    aquamarine:           Hansi["7fffd4"],
    azure:                Hansi["f0ffff"],
    beccapurple:          Hansi["663399"],
    beige:                Hansi["f5f5dc"],
    bisque:               Hansi["ffe4c4"],
    black:                Hansi["000000"],
    blanchedalmond:       Hansi["ffebcd"],
    blue:                 Hansi["0000ff"],
    blueviolet:           Hansi["8a2be2"],
    brown:                Hansi["a52a2a"],
    burlywood:            Hansi["deb887"],
    cadetblue:            Hansi["5f9ea0"],
    carnation:            Hansi["ff5ed0"],
    cayenne:              Hansi["8d0000"],
    chartreuse:           Hansi["7fff00"],
    chocolate:            Hansi["d2691e"],
    coolcopper:           Hansi["d98719"],
    copper:               Hansi["b87333"],
    coral:                Hansi["ff7f50"],
    cornflowerblue:       Hansi["6495ed"],
    cornsilk:             Hansi["fff8dc"],
    crimson:              Hansi["dc143c"],
    cyan:                 Hansi["00ffff"],
    darkblue:             Hansi["00008b"],
    darkcyan:             Hansi["008b8b"],
    darkgoldenrod:        Hansi["b8860b"],
    darkgray:             Hansi["a9a9a9"],
    darkgreen:            Hansi["006400"],
    darkgrey:             Hansi["a9a9a9"],
    darkkhaki:            Hansi["bdb76b"],
    darkmagenta:          Hansi["8b008b"],
    darkolivegreen:       Hansi["556b2f"],
    darkorange:           Hansi["ff8c00"],
    darkorchid:           Hansi["9932cc"],
    darkred:              Hansi["8b0000"],
    darksalmon:           Hansi["e9967a"],
    darkseagreen:         Hansi["8fbc8f"],
    darkslateblue:        Hansi["483d8b"],
    darkslategray:        Hansi["2f4f4f"],
    darkslategrey:        Hansi["2f4f4f"],
    darkturquoise:        Hansi["00ced1"],
    darkviolet:           Hansi["9400d3"],
    deeppink:             Hansi["ff1493"],
    deepskyblue:          Hansi["00bfbf"],
    dimgray:              Hansi["696969"],
    dimgrey:              Hansi["696969"],
    dodgerblue:           Hansi["1e90ff"],
    feldspar:             Hansi["d19275"],
    firebrick:            Hansi["b22222"],
    floralwhite:          Hansi["fffaf0"],
    forestgreen:          Hansi["228b22"],
    fuchsia:              Hansi["ff00ff"],
    gainsboro:            Hansi["dcdcdc"],
    ghostwhite:           Hansi["f8f8ff"],
    gold:                 Hansi["ffd700"],
    goldenrod:            Hansi["daa520"],
    gray:                 Hansi["808080"],
    gray10:               Hansi["1a1a1a"],
    gray20:               Hansi["333333"],
    gray30:               Hansi["4d4d4d"],
    gray40:               Hansi["666666"],
    gray50:               Hansi["808080"],
    gray60:               Hansi["999999"],
    gray70:               Hansi["b3b3b3"],
    gray80:               Hansi["cccccc"],
    gray90:               Hansi["e6e6e6"],
    green:                Hansi["008000"],
    greenyellow:          Hansi["adff2f"],
    grey:                 Hansi["808080"],
    grey10:               Hansi["1a1a1a"],
    grey20:               Hansi["333333"],
    grey30:               Hansi["4d4d4d"],
    grey40:               Hansi["666666"],
    grey50:               Hansi["808080"],
    grey60:               Hansi["999999"],
    grey70:               Hansi["b3b3b3"],
    grey80:               Hansi["cccccc"],
    grey90:               Hansi["e6e6e6"],
    honeydew:             Hansi["f0fff0"],
    hotpink:              Hansi["ff69b4"],
    indianred:            Hansi["cd5c5c"],
    indigo:               Hansi["4b0082"],
    iron:                 Hansi["4c4c4c"],
    ivory:                Hansi["fffff0"],
    khaki:                Hansi["f0e68c"],
    lavender:             Hansi["e6e6fa"],
    lavenderblush:        Hansi["fff0f5"],
    lawngreen:            Hansi["7cfc00"],
    lead:                 Hansi["191919"],
    lemonchiffon:         Hansi["fffacd"],
    lightblue:            Hansi["add8e6"],
    lightcoral:           Hansi["f08080"],
    lightcyan:            Hansi["e0ffff"],
    lightgoldenrodyellow: Hansi["fafad2"],
    lightgray:            Hansi["d3d3d3"],
    lightgreen:           Hansi["90ee90"],
    lightgrey:            Hansi["d3d3d3"],
    lightpink:            Hansi["ffb6c1"],
    lightsalmon:          Hansi["ffa07a"],
    lightseagreen:        Hansi["20b2aa"],
    lightskyblue:         Hansi["87cefa"],
    lightslateblue:       Hansi["8470ff"],
    lightslategray:       Hansi["778899"],
    lightslategrey:       Hansi["778899"],
    lightsteelblue:       Hansi["b0c4de"],
    lightyellow:          Hansi["ffffe0"],
    lime:                 Hansi["00ff00"],
    limegreen:            Hansi["32cd32"],
    linen:                Hansi["faf0e6"],
    magenta:              Hansi["ff00ff"],
    magnesium:            Hansi["b3b3b3"],
    maroon:               Hansi["800000"],
    mediumaquamarine:     Hansi["66cdaa"],
    mediumblue:           Hansi["0000cd"],
    mediumorchid:         Hansi["ba55d3"],
    mediumpurple:         Hansi["9370db"],
    mediumseagreen:       Hansi["3cb371"],
    mediumslateblue:      Hansi["7b68ee"],
    mediumspringgreen:    Hansi["00fa9a"],
    mediumturquoise:      Hansi["48d1cc"],
    mediumvioletred:      Hansi["c71585"],
    mercury:              Hansi["e6e6e6"],
    midnightblue:         Hansi["191970"],
    mintcream:            Hansi["f5fffa"],
    mistyrose:            Hansi["ffe4e1"],
    moccasin:             Hansi["ffe4b5"],
    navajowhite:          Hansi["ffdead"],
    navy:                 Hansi["000080"],
    nickel:               Hansi["808080"],
    oldlace:              Hansi["fdf5e6"],
    olive:                Hansi["808000"],
    olivedrab:            Hansi["6b8e23"],
    orange:               Hansi["ffa500"],
    orangered:            Hansi["ff4500"],
    orchid:               Hansi["da70d6"],
    palegoldenrod:        Hansi["eee8aa"],
    palegreen:            Hansi["98fb98"],
    paleturquoise:        Hansi["afeeee"],
    palevioletred:        Hansi["db7093"],
    papayawhip:           Hansi["ffefd5"],
    peachpuff:            Hansi["ffdab9"],
    peru:                 Hansi["cd853f"],
    pink:                 Hansi["ffc0cb"],
    plum:                 Hansi["dda0dd"],
    poly:                 Hansi["600000"],
    polysilicon:          Hansi["600000"],
    powderblue:           Hansi["b0e0e6"],
    purple:               Hansi["800080"],
    rebeccapurple:        Hansi["663399"],
    red:                  Hansi["ff0000"],
    rosybrown:            Hansi["bc8f8f"],
    royalblue:            Hansi["4169e1"],
    saddlebrown:          Hansi["8b4513"],
    salmon:               Hansi["fa8072"],
    sandybrown:           Hansi["f4a460"],
    seagreen:             Hansi["2e8b57"],
    seashell:             Hansi["fff5ee"],
    sienna:               Hansi["a0522d"],
    silver:               Hansi["cccccc"],
    skyblue:              Hansi["87ceeb"],
    slateblue:            Hansi["6a5acd"],
    slategray:            Hansi["708090"],
    slategrey:            Hansi["708090"],
    snow:                 Hansi["fffafa"],
    springgreen:          Hansi["00ff7f"],
    steel:                Hansi["666666"],
    steelblue:            Hansi["4682b4"],
    tan:                  Hansi["d2b48c"],
    teal:                 Hansi["008080"],
    thistle:              Hansi["d8bfd8"],
    tin:                  Hansi["7f7f7f"],
    tomato:               Hansi["ff6347"],
    tungsten:             Hansi["333333"],
    turquoise:            Hansi["40e0d0"],
    violet:               Hansi["ee82ee"],
    violetred:            Hansi["d02090"],
    wheat:                Hansi["f5deb3"],
    white:                Hansi["ffffff"],
    whitesmoke:           Hansi["f5f5f5"],
    yellow:               Hansi["ffff00"],
    yellowgreen:          Hansi["9acd32"]
  }
end